export max=1
export dsrc=rb2iniparts
export PATH=$PATH:$PWD/rb2bin

# make scripts executable

chmod 755 rb2bin/*
[ -f setx ] && set -x ## debug only 
 if [ -f nodebugit ]
then 
  echo in debugging mode .... hit enter
  read onzin
  set -x
fi 
# make scs file, proper portnr (dir should be named name-portnumber>)

portnum=`basename $PWD|cut -d- -f2`
newnr=$(( $portnum ))
echo $newnr
if [ $newnr -lt 1024 ] 
then
if [ ! -f portignore ]
then 
cat <<EOF
portnr for server = $portnr, which is not valid...

This script cannot determine portnr from dir `pwd` for your rb server.

if the dir name has the form of <something meaningfull-#portnumber>
this will be done for you...

you must now edit rb2server.scs yourself, and define the proper portnumber
or change `pwd` into for example `pwd`-47800

this nag screen will not come back. ...

hit enter to continue..

EOF
touch portignore # dont come back...
read portok

fi 

fi


cat $dsrc/templ-std/scsini.templ |sed "s/47800/$newnr/g" |\
sed "s/telnetport/$newnr/1" |sed 's/enableTelnet/\/\/enableTelnet/g' >rb2server.scs.out
cp rb2server.scs rb2server.scs.old
cp rb2server.scs.out rb2server.scs

grep $newnr rb2server.scs

# this is v2.0
ifmiss()
{

[ -d "$dsrc" ] || mkdir rb2iniparts

target=$1 


shift 1  # rest is data for target file

# mk file if not exist and fill with data
[ -f $dsrc/$target ] || echo $* > $dsrc/$target

}
## ifmiss rens aap noot mies # test it..

ifmiss modes advanced normal 
ifmiss year 1914 1915 1916 1917 1918
ifmiss maps flanders verdun marne alsace island
ifmiss tgts sierra
ifmiss regsize small medium large full
ifmiss tgtregsize small medium large full
ifmiss tgtmanual 1
ifmiss tgtmanprog 0
ifmiss lndmrkdens sparse moderate dense full
ifmiss histplanes 0
ifmiss fmodel sierra
ifmiss name "my rb3d server name"
ifmiss gamelen 5400
ifmiss tgtswaptime 900
ifmiss dates now winter spring summer fall
ifmiss times now morning noon evening midnight
ifmiss dayrate 12.0
ifmiss nightrate 12.0
ifmiss srvrtemplate std



adate()
{
sdate $1|grep -v ^#
}
atime()
{
stime $1|grep -v ^#
}
gamelen ()
{
cat $dsrc/gamelen|grep -v ^#
}
achoice()
{  # feed it list,  returns a random choice of list.
	# island flanders marne = 3 poss. nr determines which is chosen
set `echo $*`  # put list values in env
max=$#		# max number of values 
nr=$(($RANDOM % $max + 1 ))  # generate number, <= max     
# echo nr $nr $*
#  echo $(nr) value in the env, is return result of this function
eval echo $`echo $nr`  

}

amap()
{
# achoice  Marne Flanders Alsace Verdun Island 
achoice `cat $dsrc/maps|grep -v ^#`
}

## set -x ## debug only 
 if [ -f debugit ]
then 
  echo in debugging mode .... hit enter
  read onzin
  set -x
fi 

export mapname=`amap`
export mapdir=tgts-sierra
export tgts=`cat $dsrc/tgts`
# export mapdir=$dsrc/tgts-$tgts
[ -d $dsrc/tgts-$tgts ] && mapdir=tgts-$tgts
export mapfile=$mapdir/$mapname.txt
echo using : mapfile $mapdir/$mapname.txt

export lndmrks=`cat $dsrc/lndmrks`
cp $dsrc/lndmrks-sierra/* .   # copy std files, in case other are missing...
[ -d $dsrc/lndmrks-$lndmrks ] && cp $dsrc/lndmrks-$lndmrks/* . || echo ATT LANDMARKS are MISSING lndmrks-$lndmrks

# region size and density are hardcoded full. 
# use achoice and list or a file to program it.. if you want...
# experience with running servers other than full size and density are disappointing
# regionsize : small is centre of map, etc
# density : obvious
# tgtregionsize : limits from the center where tgts can be. 
# can be usefull if you want play big map with limited nr of pilots

# export tgtregsize="targetRegionSize="`achoice FULL` # full large medium small 
# export tgtregionsize="targetRegionSize="`achoice FULL ` # full large medium small 
tgtregsize=`cat $dsrc/tgtregsize`
export tgtregsize="targetRegionSize="`achoice $tgtregsize` # full large medium small 

# export regsize="regionSize="`achoice FULL` # full large medium small 
regsize=`cat $dsrc/regsize`
export regsize="regionSize="`achoice $regsize` # full large medium small 

# export landmarkdensity="landmarkDensity="`achoice FULL` # sparse moderate dense full
lndmrkdens=`cat $dsrc/lndmrkdens`
lndmrkdens=`achoice $lndmrkdens `
export landmarkdensity="landmarkDensity="$lndmrkdens # sparse moderate dense full

# start date game : pick one  its actually a season...
thedate=`achoice \`cat $dsrc/dates\` `
theyear=`achoice \`cat $dsrc/year\` `
# and feed it to sdate
export startdate="startDate=`sdate $thedate $theyear `"

# start time game : pick one
thetime=`achoice \`cat  $dsrc/times \` `

# and feed it to stime
export starttime="startTime=`stime $thetime`"


# game duration
export gamedur="gameLengthInSeconds="`cat $dsrc/gamelen`

# game mode NFM or AFM
export gamemod=`achoice \`cat $dsrc/modes\` ` # normal advanced
# fmodel : this puts the correct rbst.ini (if u put it there...) for rbst in this server folder....
# fmodel-<rb2iniparts/fmodel contents>
fmodel=`cat $dsrc/fmodel`
cp $dsrc/fmodel-$fmodel/* . || echo "ATTN  $fmodel not defined !!!!"
[ -d $dsrc/fmodel-$fmodel ]  || cp $dsrc/fmodel-sierra/* .  # copies std sierra fmodel to ensure checks..



case $gamemod in
ADVANCED|advanced) gm=AFM ;;
NORMAL|normal) gm=NFM ;;
esac
export serverdesc="serverDesc=`cat $dsrc/name ` $mapname $gm $fmodel $startdate "



cat <<EOF
______________________________________________
mapname X${mapname}X  mapfile : $mapfile
regsize $regsize 
landmarkdensity $landmarkdensity
gamemode $gamemod
tgtregionsize $tgtregionsize
startdate $startdate
starttime $starttime
echo serverdesc $serverdesc
______________________________________________

EOF
echo processing......
# set -x
# the srvrtempl var makes it possible to config rb2srvr differently ...
# e.g. password set, sec on, planesets, etc etc
# must make sure that it is called srvini.templ
# if not defined, it picks templ-std/srvrini.templ
srvrtempl=`cat $dsrc/srvrtemplate` || srvrtempl=templ-std
echo $srvrtempl = srvrtempl
ls $dsrc/templ-$srvrtempl/srvrini.templ
# less $dsrc/templ-$srvrtempl/srvrini.templ

cat $dsrc/templ-$srvrtempl/srvrini.templ |\
sed "s/useMap=*/useMap=${mapname}/g" | \
sed "s/gameMode=*/gameMode=$gamemod/g" |\
sed "s/regionSize=*/$regsize/g" |\
sed "s/targetRegionSize=*/$tgtregsize/g" |\
sed "s/startDate=*/$startdate/g" |\
sed "s/gameLengthInSeconds=*/$gamedur/g" |\
sed "s/serverDesc=*/$serverdesc/g" |\
sed "s/startTime=*/$starttime/g"  |\
sed "s/landmarkDensity=*/$landmarkdensity/g" |\
sed "s/manualTargetsProgress=/manualTargetsProgress=`cat $dsrc/tgtmanprog`/g" |\
sed "s/manuallyChooseTargets=/manuallyChooseTargets=`cat $dsrc/tgtmanual`/g"|\
sed "s/targetSwapTimeInSeconds=/targetSwapTimeInSeconds=`cat $dsrc/tgtswaptime`/g"|\
sed "s/dayRate=/dayRate=`cat $dsrc/dayrate`/g"|\
sed "s/nightRate=/nightRate=`cat $dsrc/nightrate`/g"|\
sed "s/historicAircraftDates=/historicAircraftDates=`cat $dsrc/histplanes`/g" \
> out.ini

sort -R $dsrc/$mapfile |grep -v ^$ >> out.ini
cat $dsrc/templ-std/reg+clients.templ >> out.ini

[ -f debugit ] || cp out.ini rb2server.ini

echo _________ out.ini _____________________________________
cat out.ini |grep -i -e security -e Target -e Time -e useMap -e markDens -e gameMode -e gameLeng -e targetRegion -e startDate -e startTime -e serverDesc -e regionSize -e auto -e rate
echo ____________diff out.ini rb2server __________________________________
diff out.ini rb2server.ini
ls -l debugit

exit 

historicAircraftDates=0
manualTargetsProgress=0
targetSwapTimeInSeconds=900
endOnNoTargets=0
autoRepairTargets=0
deadTargetsRemoved=1
manuallyChooseTargets=1
targetsChangeTeams=1
manualTargetsProgress=0
manualTargetsAtATime=8
